#--------------  Estimation ------------------------------------------
#   Experiement 3: Concert Pairs
#---------------------------------------------------------------------
# Requires package bayesm

#source('G:/Dropbox/Personal Space/R4/Code to share/FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive.R')
#source('G:/Dropbox/Personal Space/R4/Code to share/FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh.r')
#dyn.load("G:/Dropbox/Personal Space/R4/Code to share/PS_locational_wCov_noLambda_20180625.dll") 

# working from the working directory
#load("E3_ConcerPairs_finalData.RData")
dyn.load("PS_locational_wCov_noLambda_20180625.dll")  
source("FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh.r")
source("FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive.R")


#============================================================================
#   Example for L2+PS with Regions
#   ESTIMATION
#============================================================================

#---- NC (Choices with no-choice available)

filetouse = lgtdata_LPS_XL01_wQ_withNonChoice_INSAMPLE
L_var = c(1:2)  # rows and columns, same for all quadratic specifications
PS_var=c(1:5,9:10,14:16)    # changes as a function of which PS variables need to be included

nvarX_L = length(L_var)*2+ 1  # for the quadratic specification
nvarX_PS = length(PS_var)
nvar_cond = 1;  nlambda=1;  nz=1
npar = nvarX_L+nvarX_PS
out_nonChoices_INSAMPLE = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh  (
      Data = list(lgtdata = filetouse),
      Prior=list(nu_b = 5 + 3, V_b = 15 * diag(npar), Deltabar = matrix(rep(0, nz * (npar)), ncol = (npar)), ADelta  = 0.01 * diag(nz)),
      Mcmc=list(R=5000,keep=5,seed=333,sbeta_vec=c(0.15,0.05),switchR=10000,
                flag=3,   # changes as a function of which model speification is required
                #  flag values in R
                # 1 = locational quadratic
                # 2 = PS only
                # 3 = locational quadratic + PS
                # 4 = locational 2 par only (Kuma)
                # 6 = locational 2 par (Kuma) + PS
                # 8 = locational linear only
                # 10 = locational linear + PS
                # PSflag=2,  # old, not used anymore
                L_var = L_var,  
                PS_var=PS_var,
                Cond_var=c(1)))  # no location specific covariates specified here
# Approximate estimation time: 7.5 hours 500K MCMC draws 


#----  FC (Forced Choices)

filetouse = lgtdata_LPS_XL01_wQ_ForcedChoices_INSAMPLE
L_var = c(1:2)              # rows and columns, same for all quadratic specifications
PS_var=c(1:5,9:10,14:15)    # changes as a function of which PS variables need to be included

nvarX_L = length(L_var)*2+ 1  # for the quadratic specification
nvarX_PS = length(PS_var)
nvar_cond = 1;  nlambda=1;  nz=1
npar = nvarX_L+nvarX_PS
out_ForcedChoices_INSAMPLE = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh  (
  Data = list(lgtdata = filetouse),
  Prior=list(nu_b = 5 + 3, V_b = 15 * diag(npar), Deltabar = matrix(rep(0, nz * (npar)), ncol = (npar)), ADelta  = 0.01 * diag(nz) ),
  Mcmc=list(R=500000,keep=500,seed=333,sbeta_vec=c(0.25,0.05),switchR=10000,
            flag=3,   # changes as a function of which model speification is required
            #  flag values in R
            # 1 = locational quadratic
            # 2 = PS only
            # 3 = locational quadratic + PS
            # 4 = locational 2 par only (Kuma)
            # 6 = locational 2 par (Kuma) + PS
            # 8 = locational linear only
            # 10 = locational linear + PS
            # PSflag=2,  # old, not used anymore
            L_var = L_var,  
            PS_var=PS_var,
            Cond_var=c(1)))  # no location specific covariates specified here
# Approximate estimation time: 6 hours 500K MCMC draws 





#============================================================================
#   Example for L2+PS with Regions
#   MCMC Traceplots
#============================================================================

#---- NC (Choices with no-choice available)

filename = out_nonChoices_INSAMPLE
burnin=500;   logMargDenNR(filename$llike[-1:-burnin] )

windows();  par(mfcol=c(2,4))
matplot(filename$Deltadraw[,c(1:3)],type='l',main="Loc: 1-3",ylab=expression(beta[L]))
matplot(filename$Deltadraw[,c(4:5)],type='l',main="Loc: 4-5",ylab=expression(beta[L]))
matplot(filename$Deltadraw[,c(6:10)],type='l',main="R1: LRintFB",ylab=expression(beta[R]))
matplot(filename$Deltadraw[,c(11:12)],type='l',main="R1: cornerF, cornerB",ylab=expression(beta[R]))
matplot(filename$Deltadraw[,c(13:14)],type='l',main="R2, R3",ylab=expression(beta[R]))
matplot(filename$Deltadraw[,c(15)],type='l',main="NC",ylab=expression(beta[NC]))
matplot(filename$llike,type='l',col=1,main="log-likelihood",ylab="log-likelihood")

rbind( t(apply(filename$Deltadraw[-1:-burnin,],2,quantile, prob=c(0.025,0.05,0.5,0.95,0.975))))

#----  FC (Forced Choices)

filename = out_ForcedChoices_INSAMPLE
burnin=500;   logMargDenNR(filename$llike[-1:-burnin] )

windows();  par(mfcol=c(2,3))
matplot(filename$Deltadraw[,c(1:3)],type='l',main="Loc: 1-3",ylab=expression(beta[L]))
matplot(filename$Deltadraw[,c(4:5)],type='l',main="Loc: 4-5",ylab=expression(beta[L]))
matplot(filename$Deltadraw[,c(6:10)],type='l',main="R1: LRintFB",ylab=expression(beta[R]))
matplot(filename$Deltadraw[,c(11:12)],type='l',main="R1: cornerF, cornerB",ylab=expression(beta[R]))
matplot(filename$Deltadraw[,c(13:14)],type='l',main="R2, R3",ylab=expression(beta[R]))
#matplot(filename$Deltadraw[,c(15)],type='l',main="NC",ylab=expression(beta[NC]))
matplot(filename$llike,type='l',col=1,main="log-likelihood",ylab="log-likelihood")

rbind( t(apply(filename$Deltadraw[-1:-burnin,],2,quantile, prob=c(0.025,0.05,0.5,0.95,0.975))))


#============================================================================
#   Example for L2+PS with Regions
#   Predictive INSAMPLE and HOLDOUT    
#============================================================================

#---- NC (Choices with no-choice available)

burnin=500
filename = out_nonChoices_INSAMPLE
filetouse_IN = lgtdata_LPS_XL01_wQ_withNonChoice_INSAMPLE
filetouse_OUT = lgtdata_LPS_XL01_wQ_withNonChoice_HOLDOUT
L_var = c(1:2)  # rows and columns, same for all quadratic specifications
PS_var=c(1:5,9:10,14:16)    # changes as a function of which PS variables need to be included

nvarX_L = length(L_var)*2+ 1  # for the quadratic specification
nvarX_PS = length(PS_var)
nvar_cond = 1;  nz=1
npar = nvarX_L+nvarX_PS
nresp = length(filetouse_IN)
startBeta_predictive_X0to1_IN =  matrix(double(nresp * npar), ncol = npar, nrow = nresp )
for(i in 1:npar)
{  startBeta_predictive_X0to1_IN[,i] = rowMeans(filename$betadraw[,i,-1:-burnin])  }

Pred_out_X0to1_IN  = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive  (
  Data = list(lgtdata = filetouse_IN),
  Mcmc=list(flag=3,
            PredictiveFlag=1,
            #PSflag=2,  # not in use anymore 
            L_var = L_var,
            PS_var=PS_var,
            Cond_var=c(1),
            startBeta = startBeta_predictive_X0to1_IN, startLambda=c(1)))
Pred_out_X0to1_IN$MeanProb_sel; Pred_out_X0to1_IN$Hit_flag_count/Pred_out_X0to1_IN$totalChoices

Pred_out_X0to1_OUT = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive  (
  Data = list(lgtdata = filetouse_OUT),
  Mcmc=list(flag=3,
            PredictiveFlag=1,
            #PSflag=2,  # not in use anymore 
            L_var = L_var,
            PS_var=PS_var,
            Cond_var=c(1),
            startBeta = startBeta_predictive_X0to1_IN, startLambda=c(1)))
Pred_out_X0to1_OUT$MeanProb_sel;  Pred_out_X0to1_OUT$Hit_flag_count/Pred_out_X0to1_OUT$totalChoices  


#----  FC (Forced Choices)

burnin=500
filename = out_ForcedChoices_INSAMPLE
filetouse_IN = lgtdata_LPS_XL01_wQ_ForcedChoices_INSAMPLE
filetouse_OUT = lgtdata_LPS_XL01_wQ_ForcedChoices_HOLDOUT
L_var = c(1:2)  # rows and columns, same for all quadratic specifications
PS_var=c(1:5,9:10,14:15)    # changes as a function of which PS variables need to be included

nvarX_L = length(L_var)*2+ 1  # for the quadratic specification
nvarX_PS = length(PS_var)
nvar_cond = 1;  nz=1
npar = nvarX_L+nvarX_PS
nresp = length(filetouse_IN)
startBeta_predictive_X0to1_IN =  matrix(double(nresp * npar), ncol = npar, nrow = nresp )
for(i in 1:npar)
{  startBeta_predictive_X0to1_IN[,i] = rowMeans(filename$betadraw[,i,-1:-burnin])  }

Pred_out_X0to1_IN  = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive  (
  Data = list(lgtdata = filetouse_IN),
  Mcmc=list(flag=3,
            PredictiveFlag=1,
            #PSflag=2,  # not in use anymore 
            L_var = L_var,
            PS_var=PS_var,
            Cond_var=c(1),
            startBeta = startBeta_predictive_X0to1_IN, startLambda=c(1)))
Pred_out_X0to1_IN$MeanProb_sel; Pred_out_X0to1_IN$Hit_flag_count/Pred_out_X0to1_IN$totalChoices

Pred_out_X0to1_OUT = FUN_PS_LPSreg_het_Cpp_withCov_diffNumCh_predictive  (
  Data = list(lgtdata = filetouse_OUT),
  Mcmc=list(flag=3,
            PredictiveFlag=1,
            #PSflag=2,  # not in use anymore 
            L_var = L_var,
            PS_var=PS_var,
            Cond_var=c(1),
            startBeta = startBeta_predictive_X0to1_IN, startLambda=c(1)))
Pred_out_X0to1_OUT$MeanProb_sel;  Pred_out_X0to1_OUT$Hit_flag_count/Pred_out_X0to1_OUT$totalChoices  


#============================================================================
#   Example for L2+PS with Regions
#   Get individual betas for analysis
#============================================================================

#---- NC (Choices with no-choice available)

filename = out_nonChoices_INSAMPLE
burnin=500;
nresp = length(lgtdata_LPS_XL01_wQ_withNonChoice_INSAMPLE)
indPar_L2R1detR2R3 = matrix(0,ncol=15,nrow=nresp)
for(i in 1:15)
{ indPar_L2R1detR2R3[,i]=rowMeans(filename$betadraw[,i,-1:-burnin])}
colnames(indPar_L2R1detR2R3) <- c("r2", "c2","r1","c1","rc","L","R", "intLR","countF", "countB","countFcorners", "countBcorners", "R2incrProp","R3incrProp","NC")
qh = NULL
pid = NULL
for(h in 1:nresp)
{  pid = rbind(pid,lgtdata_LPS_XL01_wQ_withNonChoice_INSAMPLE[[h]][[1]]$PID) }
indPar_L2R1detR2R3 = cbind(pid, indPar_L2R1detR2R3)
write.table(indPar_L2R1detR2R3,file="E3_ConcertPairs_NC_indPar_L2R1detR2R3_noQ.csv",col.names = TRUE,sep=",",row.names = FALSE)

#----  FC (Forced Choices)

filename = out_ForcedChoices_INSAMPLE
burnin=500;
nresp = length(lgtdata_LPS_XL01_wQ_ForcedChoices_INSAMPLE)
indPar_L2R1detR2R3 = matrix(0,ncol=14,nrow=nresp)
for(i in 1:14)
{ indPar_L2R1detR2R3[,i]=rowMeans(filename$betadraw[,i,-1:-burnin])}
colnames(indPar_L2R1detR2R3) <- c("r2", "c2","r1","c1","rc","L","R", "intLR","countF", "countB","countFcorners", "countBcorners", "R2incrProp","R3incrProp")
qh = NULL
pid = NULL
for(h in 1:nresp)
{   pid = rbind(pid,lgtdata_LPS_XL01_wQ_ForcedChoices_INSAMPLE[[h]][[1]]$PID)}
indPar_L2R1detR2R3 = cbind(pid, indPar_L2R1detR2R3)
write.table(indPar_L2R1detR2R3,file="E3_ConcertPairs_FC_indPar_L2R1detR2R3_noQ.csv",col.names = TRUE,sep=",",row.names = FALSE)





